import java.util.*;

public class kmeans extends clusteringAlgorithm{
   /* Number of clusters */
   private int k;
   // Dimensionality of the vectors
   private int dim;
   // Threshold above which the corresponding html is prefetched
   private double prefetchThreshold;
   // array of k clusters, class cluster is used for easy bookkeeping
   private cluster[] clusters;
   
   // This class represents the clusters, it contains the prototype (the mean of all it's members)
   // and memberlists with the ID's (which are Integer objects) of the datapoints that are member of that cluster.
   // You also want to remember the previous members so you can check if the clusters are stable.
   static class cluster{
        float[] prototype;
        Vector currentMembers;
        Vector previousMembers;
        public cluster(){
            currentMembers = new Vector();
            previousMembers = new Vector();
        }
   }
   // These vectors contains the feature vectors you need; the feature vectors are float arrays.
   // Remember that you have to cast them first, since vectors return objects.
   private Vector trainData;
   private Vector testData;
   // Results of test()
   private double hitrate;
   private double accuracy;
   
   public kmeans(int k, Vector trainData, Vector testData, int dim){
        this.k = k;
        this.trainData = trainData;
        this.testData = testData; 
        this.dim = dim;
        prefetchThreshold = 0.5;    
        // Here k new cluster are initialized
        clusters = new cluster[k];
        for(int i=0; i< k; i++)
            clusters[i] = new cluster();
   }


   public boolean train(){
   //implement k-means algorithm here:
       // Step 1: Select an initial random partioning with k clusters
       // Step 2: Generate a new partition by assigning each datapoint to its closest cluster center
       // Step 3: recalculate cluster centers
       // Step 4: repeat until clustermembership stabilizes
   }

   public boolean test(){
       // iterate along all clients. Assumption: the same clients are in the same order as in the testData
       // for each client find the cluster of which it is a member
       // get the actual testData (the vector) of this client
       // iterate along all dimensions
       // and count prefetched htmls
       // count number of hits
       // count number of requests
       // set the global variables hitrate and accuracy to their appropriate value
       return true;
   }


   // The following members are called by runClustering, in order to present information to the user
   public void showTest(){
       System.out.println("Prefetch threshold="+this.prefetchThreshold);
       System.out.println("Hitrate: "+this.hitrate);
       System.out.println("Accuracy: "+this.accuracy);
       System.out.println("Hitrate+Accuracy="+(this.hitrate+this.accuracy));
   }
   public void showMembers() {
        for(int i=0; i < k; i++)
            System.out.println("\nMembers cluster["+i+"] :"+clusters[i].currentMembers);
   }    
   public void showPrototypes() {
       for(int i=0; i < k; i++){
           System.out.print("\nPrototype cluster["+i+"] :");
           for(int i2=0;i2 < dim; i2++)
                       System.out.print(clusters[i].prototype[i2]+" ");    
           System.out.println();
       }
   }  
   // with this function you can set the prefetch threshold.
   public void setPrefetchThreshold(double prefetchThreshold){
        this.prefetchThreshold = prefetchThreshold;
    }
       
}
